// (c) Copyright 2012 Cloudera, Inc. All rights reserved.
define([
  'cloudera/cmf/cloud/AddCloudHostsWizardMainBase'
], function(AddCloudHostsWizardMainBase) {
  
  describe('AddCloudHostsWizardMainBase Tests', function() {
    
    var objToTest;
    
    beforeEach(function() {
      var options = {
        maxNodes : 50, 
        messages : {},
        // In the AddCloudHostsWizardMainBase function initParams(), 
        // a statement like options.amisMap[self.selectedOs()]
        // [self.selectedRegion()] exists. self.selectedOs() and 
        // self.selectedRegion() will both be "" in the test 
        // environment.
        amisMap : {"" : {"" : ""}}
      };
      objToTest = new AddCloudHostsWizardMainBase(options);
    });
    
    it('should properly validate number of instances', function() {
      // Each entry in tests is [# of instances, expected return value 
      // of checkInvalidNumInstances()].
      var tests = [[-10, false], [0, false], [25, true], [50000, false]]; 
      var currentTestIdx = 0;
      spyOn(objToTest, 'numInstances').andCallFake(function() {
        return tests[currentTestIdx][0];
      });
      spyOn(objToTest, 'numInstancesError').andCallFake(function(value) {});
      var i;
      for (i = 0; i < tests.length; i++) {
        currentTestIdx = i;
        expect(objToTest.checkInvalidNumInstances()) 
          .toEqual(tests[currentTestIdx][1]);
      }
    });
    
    it('should properly validate custom group string', function() {
      // Each entry in tests is [custom group string, expected return value 
      // of checkInvalidCustomGroup()].
      var tests = [['*ab', false], ['ab', false], ['abc', true], ['Abc', false],
                   ['aBc', false],
                   // 63 characters
                   ['a--------------------------------------------------------------', true],
                   // 64 characters
                   ['a---------------------------------------------------------------', false],
                   ['ab_ -', true], ['1ab', true], ['_ab', false], [' ab', false]]; 
      var currentTestIdx = 0;
      spyOn(objToTest, 'customGroup').andCallFake(function() {
        return tests[currentTestIdx][0];
      });
      spyOn(objToTest, 'customGroupError').andCallFake(function(value) {});
      var i;
      for (i = 0; i < tests.length; i++) {
        currentTestIdx = i;
        expect(objToTest.checkInvalidCustomGroup()) 
          .toEqual(tests[currentTestIdx][1]);
      }
    });
  });
});
